(function(angular, $, _) {
  // Declare a list of dependencies.
  angular.module('form_processor', [
    'crmUi', 'crmUtil', 'ngRoute'
  ]);
  angular.module('form_processor').factory('formProcessorFactory', function() {
  	return {
  		getFieldList: function (inputs, actions, selectedAction) {
	  		var fields = [];
	  		angular.forEach(inputs, function(input, key) {
	  				var field = {
	  					'name': 'input.'+input.name,
	  					'label': 'Input::'+input.name
	  				};
	  				fields.push(field);
				});
				
				var skipAfter = false;
				angular.forEach(actions, function(action, key) {
					if (selectedAction && selectedAction == action) {
						skipAfter = true;
					}
					if (!skipAfter) {
						angular.forEach(action.type.output_spec, function(output_field, output_field_key) {
							var field = {
	  						'name': 'action.'+action.name+'.'+output_field.name,
	  						'label': 'Action::'+action.title+'::'+output_field.title
	  					};
	  					fields.push(field);
	  				});
					}
				});
				return fields;
  		}
		};
  });
})(angular, CRM.$, CRM._);
