(function(angular, $, _) {

  angular.module('form_processor').config(function($routeProvider) {
      $routeProvider.when('/formprocessors', {
        controller: 'FormProcessorListCtrl',
        templateUrl: '~/form_processor/FormProcessorListCtrl.html',

        // If you need to look up data when opening the page, list it out
        // under "resolve".
        resolve: {
          formProcessors: function($route, crmApi) {
            return crmApi('FormProcessorInstance', 'get', {options: {limit: 0}});
          }
        }
      });
    }
  );
  
  angular.module('form_processor').controller('FormProcessorListCtrl', function($scope, crmApi, formProcessors) {
    var ts = $scope.ts = CRM.ts(null);

    $scope.status_labels = CRM.form_processor.status_labels;
    $scope.formProcessors = formProcessors.values;
    $scope.toggleFormProcessor = function (formProcessor) {
      formProcessor.is_active = (formProcessor.is_active == '1') ? '0' : '1';
      crmApi('FormProcessorInstance', 'create', formProcessor, true)
        .catch(function (data) {
          formProcessor.is_active = (formProcessor.is_active == '1') ? '0' : '1'; // revert
          $scope.$digest();
        });
    };
    $scope.deleteFormProcessor = function (formProcessor) {
      crmApi('FormProcessorInstance', 'delete', {id: formProcessor.id}, {
        error: function (data) {
          CRM.alert(data.error_message, ts('Error'), 'error');
        }
      })
        .then(function (data) {
          delete formProcessors.values[formProcessor.id];
          $scope.$digest();
        });
    };
    $scope.revertFormProcessor = function(formProcessor) {
      if (formProcessor.status != 3) {
        return;
      }
      crmApi('FormProcessorInstance', 'revert', {id: formProcessor.id})
      .then(function (data) {
        formProcessor = data;
      });
    };
  });

})(angular, CRM.$, CRM._);