(function(angular, $, _) {

  angular.module('form_processor').controller('InputDialogCtrl', function InputDialogCtrl($scope, dialogService) {
    $scope.ts = CRM.ts(null);
    $scope.input = angular.copy($scope.model.input);
    $scope.invalidName = false;
    $scope.nameExists = false;
  	$scope.validators = CRM.form_processor.validators;
  	
  	if (!$scope.input.deletedValidators) {
  		$scope.input.deletedValidators = [];
  	}
    
    $scope.$watch('input.name', function(newName, oldName) {
    	$scope.invalidName = newName && !newName.match(/^[a-z0-9_]+$/) ? true : false;
    	$scope.nameExists = false;
    	if (newName && !$scope.invalidName) {
    		// Check whether the name already exists
    		angular.forEach($scope.model.inputs, function(input, key) {
    			if (input != $scope.input && input.name == newName) {
    				$scope.nameExists = true;
    			}
    		});
    	}
    }, true);
    
    $scope.saveClick = function() {
    	$scope.model.input = $scope.input;
    	dialogService.close('InputDialog', $scope.model);
    };
		
		$scope.cancelClick = function() {			
    	dialogService.cancel('InputDialog');
    };
    
    $scope.addValidator = function(newValidator) {
    	if (!newValidator) {
    		return;
    	}
    	var validator = {
    		validator: angular.copy(newValidator),
    		configuration: {}
    	}; 
    	$scope.input.validators.push(validator);
    };
    
    $scope.removeValidator = function(validator) {
    	var index = $scope.input.validators.indexOf(validator);
    	if (index >= 0) {
    		$scope.input.deletedValidators.push(validator);
    		$scope.input.validators.splice(index, 1);
    	}
    };
    
  });

})(angular, CRM.$, CRM._);
